#!/bin/bash

VER=$1
RD_COMM=$2
IP_ADDR=$3
TIMEOUT=$4
RESTART=$5

init () {

	if [ "$1" == "" ]; then
		VER="2c"
		IP_ADDR=`/sbin/ifconfig eth0 | sed -n 's/.*inet *addr:\([0-9\.]*\).*/\1/p'`
		SLOT=`echo $IP_ADDR | awk -F"."  '{ print  $NF }'`
		RD_COMM="int_ro_$SLOT"
		TIMEOUT=60
		RESTART="YES"
#		echo "snmp_wd  $VER $RD_COMM $IP_ADDR $TIMEOUT $RESTART"
	fi;

	if [ "$VER" == "" ]; then
		echo "Usage: $0 SNMP-VER RD_COMM IP_ADDR"
		exit -1
	fi;

	if [ "$RD_COMM" == "" ]; then
		echo "Usage: $0 SNMP-VER RD_COMM IP_ADDR"
		exit -1
	fi;

	if [ "$IP_ADDR" == "" ]; then
		echo "Usage: $0 SNMP-VER RD_COMM IP_ADDR"
		exit -1
	fi;

	if [ "$TIMEOUT" == "" ]; then
		echo "Usage: $0 SNMP-VER RD_COMM IP_ADDR TIMEOUT"
		exit -1
	fi;

	if [ "$RESTART" == "" ]; then
		RESTART="NO"
	fi;

}

test_once() {
# Test this first time, if it fails, asume wrong parameters and do not run the watchDog process
	sleep $TIMEOUT

	res=`snmpget -v $VER -c $RD_COMM $IP_ADDR 1.3.6.1.2.1.1.3.0`
	if [ "$res" == "" ]; then
#		echo "$0 test_once fail! snmpd_wd will not run!"
#		logger "$0 test_once fail! snmpd_wd will not run!"
		exit
	fi;
#	echo "$0 is running..."
#	logger "$0 is running..."
}

start_monitor () {

	while [ 1 ]
	do
		sleep $TIMEOUT

		res=`snmpget -v $VER -c $RD_COMM $IP_ADDR 1.3.6.1.2.1.1.3.0`

		if [ "$res" == "" ]; then
			echo "$0 timedout..."
			logger "$0 timedout..."
			if [ $RESTART == "YES" ]; then
				echo "$0 timedout, restart SNMP..."
				logger "$0 timedout, restart SNMP..."
				kill -9 `cat /var/run/snmpd.pid`
				sleep 300
			fi;
		fi;

	done
}

init
test_once
start_monitor
